/*console.h*/

#ifndef __CONSOLE_H__
#define __CONSOLE_H__

#include <ivaria/conin.h>
#include <ivaria/conout.h>
#include <ivaria/script.h>
#include "csutil/scf_implementation.h"
#include <csutil/refcount.h>
#include "iutil/plugin.h"

class cimConsole:public csRefCount
{
private:
	
	iObjectRegistry* object_reg;

	struct ExecCallback : public scfImplementation1<ExecCallback,iConsoleExecCallback>
  {
    ExecCallback () : scfImplementationType (this) { }
    virtual ~ExecCallback () { }
    virtual void Execute (const char* cmd);
	csRef<iScript> python;
	bool InitPython(iObjectRegistry *obj_reg);
  };

	bool visible;

public:
	csRef<iConsoleInput> conin;
	csRef<iConsoleOutput> conout;

	bool Initialize(iObjectRegistry* obj_reg);

	void Show();

	void Hide();

	void Toggle();

	bool HandleEvent (iEvent& ev);

	bool IsVisible();

};
#endif // __CONSOLE_H__
